<!-- 终止操作 -->
<script lang="ts" setup name="teminateDialog">
import type { FormInstance, FormRules } from 'element-plus'
import { ElMessage, ElMessageBox } from 'element-plus'
import { reactive, ref } from 'vue'
import { interchangeListTerminate } from '../../../../api/business/schedule/interchangeList'

// 对外暴露的方法： 退回成功
const emit = defineEmits(['onSuccess'])
// 弹窗显示状态
const dialogVisible = ref(false)
// 默认表单
const formData = ref({
  orderId: '', // 委托书id
  reason: '', // 终止原因
  sampleId: '', // 样品id
  status: '5', // 样品状态
})

// 保存按钮加载状态
const btnLoading = ref(false)

// ---------------表单提交--------------------------------
// 表单对象
const dataFormRef = ref<FormInstance>()
// 校验规则
const rules = reactive<FormRules>({
  reason: [{ required: true, message: '终止原因必填', trigger: ['blur', 'change'] }],
})
/**
 * 初始化审批弹窗
 * @param orderId 委托书id
 * @param sampleId 样品id
 */
function initDialog(row) {
  // dataFormRef.value!.clearValidate()
  formData.value.orderId = row.orderId
  formData.value.sampleId = row.sampleId
  dialogVisible.value = true
}
// 提交表单
function submitForm(formEl: FormInstance | undefined) {
  if (!formEl) { return }
  formEl.validate((valid) => {
    if (valid) {
      // ElMessageBox.confirm(
      //   '确认终止吗？',
      //   '提示',
      //   { confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning' },
      // ).then(() => {
      btnLoading.value = true
      interchangeListTerminate(formData.value).then((res) => {
        ElMessage.success('操作成功')
        btnLoading.value = false
        dialogVisible.value = false
        emit('onSuccess')
      }).catch((_) => {
        btnLoading.value = false
      })
      // })
    }
  })
}
// 关闭弹窗
function handleClose() {
  dialogVisible.value = false
}

// ----------------------- 以下是暴露的方法内容 ----------------------------
defineExpose({ initDialog })
</script>

<template>
  <el-dialog
    v-model="dialogVisible"
    title="终止"
    width="600"
    :before-close="handleClose"
  >
    <el-form
      ref="dataFormRef"
      label-position="top"
      label-width="80px"
      :model="formData"
      :rules="rules"
    >
      <el-row :gutter="24">
        <el-col :span="24">
          <el-form-item label="请输入终止原因" prop="reason">
            <el-input
              v-model="formData.reason"
              :rows="4"
              show-word-limit
              type="textarea"
            />
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <template #footer>
      <el-button type="primary" :loading="btnLoading" @click="submitForm(dataFormRef)">
        提交
      </el-button>
      <el-button type="info" @click="handleClose">
        取消
      </el-button>
    </template>
  </el-dialog>
</template>

<style lang="scss" scoped>
// 样式
</style>
